# coding: utf-8
from __future__ import absolute_import

from django.db import models

from south.db import db
from south.utils import datetime_utils as datetime
from south.v2 import SchemaMigration


class Migration(SchemaMigration):

    def forwards(self, orm):
        # Adding model 'AsyncTaskMeta'
        db.create_table(u'async_asynctaskmeta', (
            (u'id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('description', self.gf('django.db.models.fields.CharField')(max_length=400, null=True, blank=True)),
            ('location', self.gf('django.db.models.fields.CharField')(max_length=400)),
        ))
        db.send_create_signal(u'async', ['AsyncTaskMeta'])

        # Adding field 'RunningTask.task_meta'
        db.add_column(u'async_runningtask', 'task_meta',
                      self.gf('django.db.models.fields.related.ForeignKey')(to=orm['async.AsyncTaskMeta'], null=True, blank=True),
                      keep_default=False)


    def backwards(self, orm):
        # Deleting model 'AsyncTaskMeta'
        db.delete_table(u'async_asynctaskmeta')

        # Deleting field 'RunningTask.task_meta'
        db.delete_column(u'async_runningtask', 'task_meta_id')


    models = {
        u'async.asynctaskmeta': {
            'Meta': {'object_name': 'AsyncTaskMeta'},
            'description': ('django.db.models.fields.CharField', [], {'max_length': '400', 'null': 'True', 'blank': 'True'}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'location': ('django.db.models.fields.CharField', [], {'max_length': '400'})
        },
        u'async.asynctasktype': {
            'Meta': {'object_name': 'AsyncTaskType'},
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '200'})
        },
        u'async.runningtask': {
            'Meta': {'object_name': 'RunningTask'},
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': u"orm['contenttypes.ContentType']", 'null': 'True', 'blank': 'True'}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'object_id': ('django.db.models.fields.PositiveIntegerField', [], {'null': 'True', 'blank': 'True'}),
            'queued_on': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'db_index': 'True'}),
            'status': ('django.db.models.fields.SmallIntegerField', [], {'default': '1', 'db_index': 'True'}),
            'task_id': ('django.db.models.fields.CharField', [], {'max_length': '36'}),
            'task_meta': ('django.db.models.fields.related.ForeignKey', [], {'to': u"orm['async.AsyncTaskMeta']", 'null': 'True', 'blank': 'True'}),
            'task_type': ('django.db.models.fields.related.ForeignKey', [], {'default': '1', 'to': u"orm['async.AsyncTaskType']"})
        },
        u'contenttypes.contenttype': {
            'Meta': {'ordering': "('name',)", 'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        }
    }

    complete_apps = ['async']
