# coding: utf-8
from __future__ import absolute_import

from django.db import models

from south.db import db
from south.utils import datetime_utils as datetime
from south.v2 import SchemaMigration


class Migration(SchemaMigration):

    def forwards(self, orm):
        # Adding field 'SmevProvider.service_name'
        db.add_column('ws_log_smevprovider', 'service_name',
                      self.gf('django.db.models.fields.CharField')(default=u'', max_length=100),
                      keep_default=False)

        # Adding field 'SmevProvider.service_address_status_changes'
        db.add_column('ws_log_smevprovider', 'service_address_status_changes',
                      self.gf('django.db.models.fields.CharField')(default=u'', max_length=100),
                      keep_default=False)

        # Adding unique constraint on 'SmevProvider', fields ['mnemonics', 'address']
        db.create_unique('ws_log_smevprovider', ['mnemonics', 'address'])


    def backwards(self, orm):
        # Removing unique constraint on 'SmevProvider', fields ['mnemonics', 'address']
        db.delete_unique('ws_log_smevprovider', ['mnemonics', 'address'])

        # Deleting field 'SmevProvider.service_name'
        db.delete_column('ws_log_smevprovider', 'service_name')

        # Deleting field 'SmevProvider.service_address_status_changes'
        db.delete_column('ws_log_smevprovider', 'service_address_status_changes')


    models = {
        'ws_log.smevlog': {
            'Meta': {'object_name': 'SmevLog'},
            'direction': ('django.db.models.fields.SmallIntegerField', [], {}),
            'error': ('django.db.models.fields.TextField', [], {'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'interaction_type': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'method_name': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'method_verbose_name': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'request': ('django.db.models.fields.TextField', [], {'null': 'True', 'blank': 'True'}),
            'response': ('django.db.models.fields.TextField', [], {'null': 'True', 'blank': 'True'}),
            'service_address': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'time': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'})
        },
        'ws_log.smevprovider': {
            'Meta': {'unique_together': "(('mnemonics', 'address'),)", 'object_name': 'SmevProvider'},
            'address': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'entity': ('django.db.models.fields.CharField', [], {'max_length': '255', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'mnemonics': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'service_address_status_changes': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'service_name': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'source': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        }
    }

    complete_apps = ['ws_log']
