# coding: utf-8
from __future__ import absolute_import

from south.db import db
from south.v2 import SchemaMigration


class Migration(SchemaMigration):

    def forwards(self, orm):
        # Adding field 'SmevLog.consumer_type'
        db.add_column('ws_log_smevlog', 'consumer_type',
                      self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=1, null=True, blank=True),
                      keep_default=False)

        # Adding field 'SmevLog.consumer_name'
        db.add_column('ws_log_smevlog', 'consumer_name',
                      self.gf('django.db.models.fields.CharField')(max_length=100, null=True, blank=True),
                      keep_default=False)

        # Adding field 'SmevLog.source'
        db.add_column('ws_log_smevlog', 'source',
                      self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=None, null=True, blank=True),
                      keep_default=False)

        # Adding field 'SmevLog.target_name'
        db.add_column('ws_log_smevlog', 'target_name',
                      self.gf('django.db.models.fields.CharField')(max_length=100, null=True, blank=True),
                      keep_default=False)

        # Переименовывает колонку error в result
        db.rename_column('ws_log_smevlog', 'error', 'result')

    def backwards(self, orm):
        # Deleting field 'SmevLog.consumer_type'
        db.delete_column('ws_log_smevlog', 'consumer_type')

        # Deleting field 'SmevLog.consumer_name'
        db.delete_column('ws_log_smevlog', 'consumer_name')

        # Deleting field 'SmevLog.source'
        db.delete_column('ws_log_smevlog', 'source')

        # Deleting field 'SmevLog.target_name'
        db.delete_column('ws_log_smevlog', 'target_name')

        # Переименовывает колонку result в error
        db.rename_column('ws_log_smevlog', 'result', 'error')


    models = {
        'ws_log.smevlog': {
            'Meta': {'object_name': 'SmevLog'},
            'consumer_name': ('django.db.models.fields.CharField', [], {'max_length': '100', 'null': 'True', 'blank': 'True'}),
            'consumer_type': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '1', 'null': 'True', 'blank': 'True'}),
            'direction': ('django.db.models.fields.SmallIntegerField', [], {}),
            'error': ('django.db.models.fields.TextField', [], {'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'interaction_type': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'method_name': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'method_verbose_name': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'request': ('django.db.models.fields.TextField', [], {'null': 'True', 'blank': 'True'}),
            'response': ('django.db.models.fields.TextField', [], {'null': 'True', 'blank': 'True'}),
            'service_address': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'source': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': 'None', 'null': 'True', 'blank': 'True'}),
            'target_name': ('django.db.models.fields.CharField', [], {'max_length': '100', 'null': 'True', 'blank': 'True'}),
            'time': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'})
        },
        'ws_log.smevprovider': {
            'Meta': {'unique_together': "(('mnemonics', 'address'),)", 'object_name': 'SmevProvider'},
            'address': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'entity': ('django.db.models.fields.CharField', [], {'max_length': '255', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'mnemonics': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'service_address_status_changes': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'service_name': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'source': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        }
    }

    complete_apps = ['ws_log']
